/*  zweic -- a compiler for zwei
 *
 *  Stephane Micheloud & LAMP
 *
 *  $Id: Type.scala 2088 2005-11-11 11:16:26 +0100 (Fri, 11 Nov 2005) michelou $
 */

package zweic;

// Internal type
abstract class Type {

  override def toString(): String = this match {
    // ...  complter ...
    case IBadType => "<Bad>"
  }

  def isSubtype(that: Type): Boolean = Pair(this, that) match {
    // ...  complter ...
    case _ => false
  }

  def isSametype(that: Type): Boolean = Pair(this, that) match {
    // ...  complter ...
    case _ => false
  }

  def lub(that: Type): Option[Type] = Pair(this, that) match {
    // ...  complter ...
    case _ => None
  }

}

// Class type
case class IClassType(c: ClassSymbol) extends Type;

// Integer type
case object IIntType extends Type;

// Null type
case object INullType extends Type;

// Bad type
case object IBadType extends Type;
